diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoorTinted.java b/src/main/java/net/minecraft/core/block/BlockTrapDoorTinted.java
new file mode 100644
index 000000000..c5bca7d7d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockTrapDoorTinted.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class BlockTrapDoorTinted extends BlockTrapDoor{
+    public BlockTrapDoorTinted(String key, int id, Material material, boolean isIron) {
+        super(key, id, material, isIron);
+    }
+    @Override
+    public boolean blocksLight()
+    {
+        return true;
+    }
+
+    @Override
+    public int getRenderBlockPass()
+    {
+        return 1;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index 65ab75554..7c9cca677 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -1,12 +1,7 @@
 package net.minecraft.core.entity;
 
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.CompoundTag;
-
 import net.minecraft.core.Global;
 import net.minecraft.core.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -20,6 +15,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
@@ -29,8 +25,9 @@ import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
-import java.util.Random;
+import java.util.Map;
 
 // Referenced classes of package net.minecraft.src:
 //            Entity, Vec3D, World, Material,
@@ -95,9 +92,8 @@ public abstract class EntityLiving extends Entity
     }
 
     @Override
-	public String getEntityTexture()
-    {
-        return "/mob/" + skinName + "/" + getSkinVariant() + ".png";
+	public String getEntityTexture() {
+        return String.format("/assets/%s/textures/entity/%s/%d.png", textureIdentifier.namespace, textureIdentifier.value, getSkinVariant());
     }
 
     public int getSkinVariant() {
@@ -109,9 +105,8 @@ public abstract class EntityLiving extends Entity
         entityData.set(1, (byte)(MathHelper.clamp(skinVariant, 0, Byte.MAX_VALUE)));
     }
 
-    public String getDefaultEntityTexture()
-    {
-        return "/mob/" + skinName + "/0.png";
+    public String getDefaultEntityTexture() {
+        return String.format("/assets/%s/textures/entity/%s/0.png", textureIdentifier.namespace, textureIdentifier.value);
     }
 
     @Override
@@ -1282,7 +1277,7 @@ public abstract class EntityLiving extends Entity
     protected int numTicksToChaseTarget;
     public String nickname = "";
     public byte chatColor = 0;
-    protected String skinName = "char";
+    protected NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
     protected float lastStrafe = 0.0f;
     
     public boolean isSkating = false;
diff --git a/src/main/java/net/minecraft/core/entity/EntityPainting.java b/src/main/java/net/minecraft/core/entity/EntityPainting.java
index c3fc62647..da621a032 100644
--- a/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet25EntityPainting;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -331,22 +332,22 @@ public class EntityPainting extends Entity
             MinecraftServer.getInstance().playerList.sendPacketToAllPlayers(new Packet25EntityPainting(this));
         }
     }
-    private static final HashMap<String, String> borderMaterialMap = new HashMap<>();
-    public static void addBorder(ItemStack stack, String imagePath){
+    private static final HashMap<String, NamespaceID> borderMaterialMap = new HashMap<>();
+    public static void addBorder(ItemStack stack, NamespaceID imagePath){
         borderMaterialMap.put(stack.itemID + "|" + stack.getMetadata(), imagePath);
     }
-    public static String getBorder(ItemStack stack){
+    public static NamespaceID getBorder(ItemStack stack){
         return borderMaterialMap.get(stack.itemID + "|" + stack.getMetadata());
     }
     static {
-        addBorder(Item.ingotIron.getDefaultStack(), "/art/borders/border_iron.png");
-        addBorder(Item.ingotGold.getDefaultStack(), "/art/borders/border_gold.png");
-        addBorder(Item.ingotSteel.getDefaultStack(), "/art/borders/border_steel.png");
-        addBorder(new ItemStack(Item.dye, 1, 4), "/art/borders/border_lapis.png");
-        addBorder(Item.diamond.getDefaultStack(), "/art/borders/border_diamond.png");
-        addBorder(Item.dustRedstone.getDefaultStack(), "/art/borders/border_redstone.png");
-        addBorder(Item.olivine.getDefaultStack(), "/art/borders/border_olivine.png");
-        addBorder(Item.quartz.getDefaultStack(), "/art/borders/border_quartz.png");
+        addBorder(Item.ingotIron.getDefaultStack(), new NamespaceID("minecraft", "border_iron"));
+        addBorder(Item.ingotGold.getDefaultStack(), new NamespaceID("minecraft", "border_gold"));
+        addBorder(Item.ingotSteel.getDefaultStack(), new NamespaceID("minecraft", "border_steel"));
+        addBorder(new ItemStack(Item.dye, 1, 4), new NamespaceID("minecraft", "border_lapis"));
+        addBorder(Item.diamond.getDefaultStack(), new NamespaceID("minecraft", "border_diamond"));
+        addBorder(Item.dustRedstone.getDefaultStack(), new NamespaceID("minecraft", "border_redstone"));
+        addBorder(Item.olivine.getDefaultStack(), new NamespaceID("minecraft", "border_olivine"));
+        addBorder(Item.quartz.getDefaultStack(), new NamespaceID("minecraft", "border_quartz"));
     }
     private int updateCounter;
     public int direction;
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityChicken.java b/src/main/java/net/minecraft/core/entity/animal/EntityChicken.java
index 4d02a290c..706f9d260 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityChicken.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityChicken.java
@@ -6,6 +6,7 @@ package net.minecraft.core.entity.animal;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.item.Item;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
 public class EntityChicken extends EntityAnimal
@@ -18,7 +19,7 @@ public class EntityChicken extends EntityAnimal
         field_752_b = 0.0F;
         destPos = 0.0F;
         field_755_h = 1.0F;
-        skinName = "chicken";
+        textureIdentifier = new NamespaceID("minecraft", "chicken");
         setSize(0.4F, 0.8F);
         timeUntilNextEgg = random.nextInt(6000) + 6000;
         mobDrops.add(new WeightedRandomLootObject(Item.featherChicken.getDefaultStack(), 0, 2));
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityCow.java b/src/main/java/net/minecraft/core/entity/animal/EntityCow.java
index 2b308b7d6..4878e4d23 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityCow.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityCow.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemBucketEmpty;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
 public class EntityCow extends EntityAnimal
@@ -19,7 +20,7 @@ public class EntityCow extends EntityAnimal
     public EntityCow(World world)
     {
         super(world);
-        skinName = "cow";
+        textureIdentifier = new NamespaceID("minecraft", "cow");
         setSize(0.9F, 1.3F);
         mobDrops.add(new WeightedRandomLootObject(Item.leather.getDefaultStack(), 1, 5));
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityPig.java b/src/main/java/net/minecraft/core/entity/animal/EntityPig.java
index 8a5217753..068acdc77 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityPig.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityPig.java
@@ -13,6 +13,7 @@ import net.minecraft.core.entity.monster.EntityPigZombie;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
@@ -24,7 +25,7 @@ public class EntityPig extends EntityAnimal
     public EntityPig(World world)
     {
         super(world);
-        skinName = "pig";
+        textureIdentifier = new NamespaceID("minecraft", "pig");
         setSize(0.9F, 0.9F);
         mobDrops.add(new WeightedRandomLootObject(Item.foodPorkchopRaw.getDefaultStack(), 1, 2));
         burningMobDrops.add(new WeightedRandomLootObject(Item.foodPorkchopCooked.getDefaultStack(), 1, 2));
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java b/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java
index 277a83beb..797bdabb8 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java
@@ -5,10 +5,10 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.item.ItemToolShears;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
@@ -26,7 +26,7 @@ public class EntitySheep extends EntityAnimal
     public EntitySheep(World world)
     {
         super(world);
-        skinName = "sheep";
+        textureIdentifier = new NamespaceID("minecraft", "sheep");
         setSize(0.9F, 1.3F);
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntitySquid.java b/src/main/java/net/minecraft/core/entity/animal/EntitySquid.java
index 3add3ec2e..cdf580f08 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntitySquid.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntitySquid.java
@@ -6,11 +6,10 @@ package net.minecraft.core.entity.animal;
 //            EntityPlayer
 
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -37,7 +36,7 @@ public class EntitySquid extends EntityWaterAnimal
         randomMotionVecZ = 0.0F;
         tickOutOfWater = 5;
         isInWater();
-        skinName = "squid";
+        textureIdentifier = new NamespaceID("minecraft", "squid");
         setSize(0.95F, 0.95F);
         animationVelocity = (1.0F / (random.nextFloat() + 1.0F)) * 0.2F;
         mobDrops.add(new WeightedRandomLootObject(Item.dye.getDefaultStack(), 1, 3));
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index 662a5ad6a..f46ed46a3 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -10,6 +10,7 @@ import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.pathfinder.Path;
@@ -32,7 +33,7 @@ public class EntityWolf extends EntityAnimal
     {
         super(world);
         looksWithInterest = false;
-        skinName = "wolf";
+        textureIdentifier = new NamespaceID("minecraft", "wolf");
         setSize(0.8F, 0.8F);
         moveSpeed = 1.1F;
         scoreValue = 500;
@@ -58,7 +59,7 @@ public class EntityWolf extends EntityAnimal
         ArmorMaterial material = null;
         String name = entityData.getString(19);
         for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
-            if (mat.name.equalsIgnoreCase(name)) {
+            if (mat.identifier.toString().equalsIgnoreCase(name)) {
                 material = mat;
                 break;
             }
@@ -76,7 +77,7 @@ public class EntityWolf extends EntityAnimal
         if (material == null) {
             entityData.set(19, "");
         } else {
-            entityData.set(19, material.name);
+            entityData.set(19, material.identifier.toString());
         }
     }
 
@@ -91,11 +92,11 @@ public class EntityWolf extends EntityAnimal
     {
         if(isWolfTamed())
         {
-            return "/mob/wolf_tame/" + getSkinVariant() + ".png";
+            return "/assets/minecraft/textures/entity/wolf_tame/" + getSkinVariant() + ".png";
         }
         else if(isWolfAngry())
         {
-            return "/mob/wolf_angry/" + getSkinVariant() + ".png";
+            return "/assets/minecraft/textures/entity/wolf_angry/" + getSkinVariant() + ".png";
         }
         else
         {
@@ -108,11 +109,11 @@ public class EntityWolf extends EntityAnimal
     {
         if(isWolfTamed())
         {
-            return "/mob/wolf_tame/0.png";
+            return "/assets/minecraft/textures/entity/wolf_tame/0.png";
         }
         else if(isWolfAngry())
         {
-            return "/mob/wolf_angry/0.png";
+            return "/assets/minecraft/textures/entity/wolf_angry/0.png";
         }
         else
         {
@@ -182,7 +183,7 @@ public class EntityWolf extends EntityAnimal
             String name = tag.getString("Armor");
             if (!name.isEmpty()){
                 for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
-                    if (mat.name.equalsIgnoreCase(name)) {
+                    if (mat.identifier.toString().equalsIgnoreCase(name)) {
                         material = mat;
                         break;
                     }
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java b/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
index dbc518430..bad5261e2 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityArmoredZombie.java
@@ -4,17 +4,16 @@ package net.minecraft.core.entity.monster;
 //            EntityMob, World, MathHelper, Item
 
 
-
-import java.util.ArrayList;
-import java.util.List;
-
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.World;
 
+import java.util.ArrayList;
+import java.util.List;
 import java.util.Random;
 
 public class EntityArmoredZombie extends EntityZombie
@@ -23,7 +22,7 @@ public class EntityArmoredZombie extends EntityZombie
     public EntityArmoredZombie(World world)
     {
         super(world);
-        skinName = "zombie_armored";
+        textureIdentifier = new NamespaceID("minecraft", "zombie_armored");
         Random rand = new Random();
         setHoldingSword(rand.nextInt(5)==0);
         List<Integer> armorItems = new ArrayList<>();
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java b/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
index 312ee1ce6..16380e8a0 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLightningBolt;
 import net.minecraft.core.item.Item;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
 public class EntityCreeper extends EntityMonster
@@ -17,7 +18,7 @@ public class EntityCreeper extends EntityMonster
     public EntityCreeper(World world)
     {
         super(world);
-        skinName = "creeper";
+        textureIdentifier = new NamespaceID("minecraft", "creeper");
         scoreValue = 800;
         setSize(0.6F, 1.6F);
         mobDrops.add(new WeightedRandomLootObject(Item.sulphur.getDefaultStack(), 0, 2));
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java b/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java
index 640cc5ca4..e3f7c39bd 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java
@@ -6,6 +6,7 @@ package net.minecraft.core.entity.monster;
 //            Vec3D, Item
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.EntityFireball;
@@ -29,7 +30,7 @@ public class EntityGhast extends EntityFlying
         aggroCooldown = 0;
         prevAttackCounter = 0;
         attackCounter = 0;
-        skinName = "ghast";
+        textureIdentifier = new NamespaceID("minecraft", "ghast");
         setSize(4F, 7F);
         fireImmune = true;
         scoreValue = 1000;
@@ -53,7 +54,7 @@ public class EntityGhast extends EntityFlying
         }
         else
         {
-            return "/mob/ghast_fire/" + getSkinVariant() + ".png";
+            return "/assets/minecraft/textures/entity/ghast_fire/" + getSkinVariant() + ".png";
         }
     }
 
@@ -66,7 +67,7 @@ public class EntityGhast extends EntityFlying
         }
         else
         {
-            return "/mob/ghast_fire/0.png";
+            return "/assets/minecraft/textures/entity/ghast_fire/0.png";
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java b/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java
index 2a595d13c..c196c8446 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java
@@ -4,6 +4,7 @@ package net.minecraft.core.entity.monster;
 // Referenced classes of package net.minecraft.src:
 //            EntityMob, World
 
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
 public class EntityGiant extends EntityMonster
@@ -12,7 +13,7 @@ public class EntityGiant extends EntityMonster
     public EntityGiant(World world)
     {
         super(world);
-        skinName = "zombie";
+        textureIdentifier = new NamespaceID("minecraft", "zombie");
         moveSpeed = 0.5F;
         attackStrength = 50;
         heightOffset *= 6F;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityPigZombie.java b/src/main/java/net/minecraft/core/entity/monster/EntityPigZombie.java
index 0f3c53f7e..2c4a21eed 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityPigZombie.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityPigZombie.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -26,7 +27,7 @@ public class EntityPigZombie extends EntityZombie
         super(world);
         angerLevel = 0;
         randomSoundDelay = 0;
-        skinName = "pigzombie";
+        textureIdentifier = new NamespaceID("minecraft", "pigzombie");
         moveSpeed = 0.5F;
         attackStrength = 5;
         fireImmune = false;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java b/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java
index 7bb168abd..8cb38c277 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java
@@ -7,6 +7,7 @@ package net.minecraft.core.entity.monster;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.item.Item;
 import com.mojang.nbt.CompoundTag;
@@ -18,7 +19,7 @@ public class EntityScorpion extends EntityMonster
     public EntityScorpion(World world)
     {
         super(world);
-        skinName = "scorpion";
+        textureIdentifier = new NamespaceID("minecraft", "scorpion");
         setSize(1F, 0.2F);
         moveSpeed = 0.8F;
         scoreValue = 200;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java b/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java
index fc1b0dc41..8deb6a437 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.EntityArrow;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -20,7 +21,7 @@ public class EntitySkeleton extends EntityMonster
     public EntitySkeleton(World world)
     {
         super(world);
-        skinName = "skeleton";
+        textureIdentifier = new NamespaceID("minecraft", "skeleton");
         scoreValue = 500;
         mobDrops.add(new WeightedRandomLootObject(Item.ammoArrow.getDefaultStack(), 0, 2));
         mobDrops.add(new WeightedRandomLootObject(Item.bone.getDefaultStack(), 0, 2));
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
index 057928564..c3bc0d14c 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
@@ -9,6 +9,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -25,7 +26,7 @@ public class EntitySlime extends EntityLiving
     {
         super(world);
         slimeJumpDelay = 0;
-        skinName = "slime";
+        textureIdentifier = new NamespaceID("minecraft", "slime");
         heightOffset = 0.0F;
         slimeJumpDelay = 20;
         scoreValue = 100;
@@ -35,7 +36,7 @@ public class EntitySlime extends EntityLiving
     {
         super(world);
         slimeJumpDelay = 0;
-        skinName = "slime";
+        textureIdentifier = new NamespaceID("minecraft", "slime");
         heightOffset = 0.0F;
         slimeJumpDelay = 20;
         scoreValue = 100;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
index ec36a28fc..9b9e2b196 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
@@ -7,6 +7,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.EntitySnowball;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.world.World;
@@ -21,7 +22,7 @@ public class EntitySnowman extends EntityMonster
     public EntitySnowman(World world)
     {
         super(world);
-        skinName = "snowman";
+        textureIdentifier = new NamespaceID("minecraft", "snowman");
         moveSpeed = 0.5F;
         attackStrength = 5;
         scoreValue = 300;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySpider.java b/src/main/java/net/minecraft/core/entity/monster/EntitySpider.java
index 5b9b12698..8f3712397 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySpider.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySpider.java
@@ -8,6 +8,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -18,7 +19,7 @@ public class EntitySpider extends EntityMonster
     public EntitySpider(World world)
     {
         super(world);
-        skinName = "spider";
+        textureIdentifier = new NamespaceID("minecraft", "spider");
         setSize(1.4F, 0.9F);
         moveSpeed = 0.8F;
         scoreValue = 200;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityZombie.java b/src/main/java/net/minecraft/core/entity/monster/EntityZombie.java
index 82a52c88c..49832f78b 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityZombie.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityZombie.java
@@ -5,6 +5,7 @@ package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.World;
@@ -15,7 +16,7 @@ public class EntityZombie extends EntityMonster
     public EntityZombie(World world)
     {
         super(world);
-        skinName = "zombie";
+        textureIdentifier = new NamespaceID("minecraft", "zombie");
         moveSpeed = 0.5F;
         attackStrength = 5;
         scoreValue = 300;
diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index 973776d4a..f9366a192 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -1,17 +1,10 @@
 package net.minecraft.core.entity.player;
 
-import java.util.ArrayList;
-import java.util.Comparator;
-import java.util.Iterator;
-import java.util.List;
-
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-
 import net.minecraft.core.achievement.AchievementList;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockBed;
 import net.minecraft.core.block.entity.TileEntity;
@@ -21,7 +14,12 @@ import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.*;
+import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityBobber;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.animal.EntityPig;
 import net.minecraft.core.entity.animal.EntityWolf;
 import net.minecraft.core.entity.monster.EntityCreeper;
@@ -44,6 +42,7 @@ import net.minecraft.core.player.inventory.Container;
 import net.minecraft.core.player.inventory.ContainerPlayer;
 import net.minecraft.core.player.inventory.IInventory;
 import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -52,6 +51,11 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weather;
 
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.Iterator;
+import java.util.List;
+
 public abstract class EntityPlayer extends EntityLiving
 {
 
@@ -74,7 +78,7 @@ public abstract class EntityPlayer extends EntityLiving
         entityType = "humanoid";
         unusedRotation2 = 180F;
         fireImmuneTicks = 20;
-        skinName = "char";
+        textureIdentifier = new NamespaceID("minecraft", "char");
         damageRemainder = 0;
     }
     @Override
